summaryrefslogtreecommitdiffstats
path: root/rsnapshot
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2011-05-09 12:59:47 +0000
committer Eric Hameleers <alien@slackware.com>2011-05-09 12:59:47 +0000
commit7e5516b5275d63f764a3752f0e9909236576fbe2 (patch)
treed1bca681c640612444c9407cf49eb79e3f31310c /rsnapshot
parent3c80f49ec11317cc8a7c2e85de2e623088f0fe70 (diff)
downloadasb-7e5516b5275d63f764a3752f0e9909236576fbe2.tar.gz
asb-7e5516b5275d63f764a3752f0e9909236576fbe2.tar.xz
Updated to 1.3.1
Diffstat (limited to 'rsnapshot')
-rwxr-xr-xrsnapshot/build/rsnapshot.SlackBuild329
1 files changed, 152 insertions, 177 deletions
diff --git a/rsnapshot/build/rsnapshot.SlackBuild b/rsnapshot/build/rsnapshot.SlackBuild
index 658404ae..138f839e 100755
--- a/rsnapshot/build/rsnapshot.SlackBuild
+++ b/rsnapshot/build/rsnapshot.SlackBuild
@@ -1,102 +1,136 @@
#!/bin/sh
-# Copyright (c) 2006 Eric Hameleers <alien@slackware.com>
-# Distributed under the terms of the GNU General Public License, Version 2
+# $Id$
+# Copyright 2006, 2011 Eric Hameleers, Eindhoven, NL
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
# -----------------------------------------------------------------------------
#
# Slackware SlackBuild script
# ===========================
-# By: Eric Hameleers <alien@slackware.com>
-# For: rsnapshot
-# Descr: a remote backup program that uses rsync
-# URL: http://rsnapshot.sf.net/
-# Needs:
-# Changelog:
-# 1.2.1-1: 20/Mar/2006 by Eric Hameleers <alien@slackware.com>
-# * Initial build.
+# By: Eric Hameleers <alien@slackware.com>
+# For: rsnapshot
+# Descr: local and remote filesystem snapshot utility
+# URL: http://rsnapshot.org/
+# Needs:
+# Changelog:
+# 1.2.1-1: 20/Mar/2006 by Eric Hameleers <alien@slackware.com>
+# * Initial build.
+# 1.3.1-1: 09/May/2011 by Eric Hameleers <alien@slackware.com>
+# * Updated for Slackware 13.x
#
-# Run 'sh SlackBuild --cleanup' to build a Slackware package.
-# The package (.tgz) plus descriptive .txt file are created in /tmp .
-# Install using 'installpkg'.
+# Run 'sh rsnapshot.SlackBuild' to build a Slackware package.
+# The package (.tgz) and .txt file as well as build logs are created in /tmp .
+# Install it using 'installpkg'.
#
# -----------------------------------------------------------------------------
-# --- INIT ---
# Set initial variables:
-CWD=`pwd`
-if [ "$TMP" = "" ]; then
- TMP=/tmp
-fi
PRGNAM=rsnapshot
-VERSION=1.2.1
-ARCH=${ARCH:-i486}
-BUILD=1
+VERSION=${VERSION:-1.3.1}
+BUILD=${BUILD:-1}
+NUMJOBS=${NUMJOBS:" -j4 "}
+TAG=${TAG:-alien}
DOCS="AUTHORS COPYING ChangeLog INSTALL NEWS README TODO utils"
-# If you have more source files, list them here as SOURCE[1], SOURCE[2], etc.
-# If you know the URL for a source file, you can put that into the SRCURL[]
-# variable, and the SlackBuild script will try to download it for you.
+# Where do we look for sources?
+SRCDIR=$(cd $(dirname $0); pwd)
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+# Input URL: http://rsnapshot.org/downloads/rsnapshot-1.3.1.tar.gz
+SOURCE="$SRCDIR/${PRGNAM}-${VERSION}.tar.gz"
+SRCURL="http://rsnapshot.org/downloads/${PRGNAM}-${VERSION}.tar.gz"
-SOURCE[0]="${PRGNAM}-${VERSION}.tar.gz"
-SRCURL[0]="http://www.rsnapshot.org/downloads/${PRGNAM}-${VERSION}.tar.gz"
##
## --- with a little luck, you won't have to edit below this point --- ##
##
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) export ARCH=i486 ;;
+ arm*) export ARCH=arm ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) export ARCH=$( uname -m ) ;;
+ esac
+fi
+
case "$ARCH" in
- i386) SLKCFLAGS="-O2 -march=i386 -mcpu=i686"
- SLKLDFLAGS=""; LIBDIRSUFFIX=""
- ;;
- i486) SLKCFLAGS="-O2 -march=i486 -mcpu=i686"
- SLKLDFLAGS=""; LIBDIRSUFFIX=""
- ;;
- s390) SLKCFLAGS="-O2"
- SLKLDFLAGS=""; LIBDIRSUFFIX=""
- ;;
- powerpc) SLKCFLAGS="-O2"
+ i486) SLKCFLAGS="-O2 -march=i486 -mtune=i686"
SLKLDFLAGS=""; LIBDIRSUFFIX=""
;;
x86_64) SLKCFLAGS="-O2 -fPIC"
SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
;;
- athlon-xp) SLKCFLAGS="-march=athlon-xp -O3 -pipe -fomit-frame-pointer"
+ *) SLKCFLAGS="-O2"
SLKLDFLAGS=""; LIBDIRSUFFIX=""
;;
esac
-PKG=$TMP/package-$PRGNAM
-
-if [ ! -d $TMP/tmp-$PRGNAM ]; then
- mkdir -p $TMP/tmp-$PRGNAM # location to build the source
-elif [ "$1" != "--oldbuild" ]; then
- # If the "--oldbuild" parameter is present, we keep
- # the old build files and continue;
- # By default we remove the remnants of previous build and continue:
- rm -rf $TMP/tmp-$PRGNAM/*
-fi
-
-
-# --- SOURCE FILE AVAILABILITY ---
-
-for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
- if ! [ -f ${CWD}/${SOURCE[$i]} ]; then
- if ! [ "${SRCURL[$i]}" = "" ]; then
- echo "Source '${SOURCE[$i]}' not available yet... will download now:"
- wget -nv -O "${CWD}/${SOURCE[$i]}" "${SRCURL[$i]}"
- if [ $? -ne 0 ]; then
- echo "Downloading '${SOURCE[$i]}' failed... aborting the build."
- exit 1
- fi
- else
- echo "File '${SOURCE[$i]}' not available... aborting the build."
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Save old umask and set to 0022:
+_UMASK_=$(umask)
+umask 0022
+
+# Create working directories:
+mkdir -p $OUTPUT # place for the package to be saved
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # always erase old package's contents
+rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
+rm -rf $OUTPUT/{configure,make,install,error,makepkg}-$PRGNAM.log
+ # remove old log files
+
+# Source file availability:
+if ! [ -f ${SOURCE} ]; then
+ echo "Source '$(basename ${SOURCE})' not available yet..."
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/$(basename $SOURCE)"
+ if [ -f ${SOURCE} ]; then echo "Ah, found it!"; continue; fi
+ if ! [ "x${SRCURL}" == "x" ]; then
+ echo "Will download file to $(dirname $SOURCE)"
+ wget -nv -T 20 -O "${SOURCE}" "${SRCURL}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
+ echo "Downloading '$(basename ${SOURCE})' failed... aborting the build."
+ mv -f "${SOURCE}" "${SOURCE}".FAIL
exit 1
fi
+ else
+ echo "File '$(basename ${SOURCE})' not available... aborting the build."
+ exit 1
fi
-done
+fi
-if [ "$1" == "--download" ]; then
+if [ "$P1" == "--download" ]; then
echo "Download complete."
exit 0
fi
@@ -107,84 +141,51 @@ echo "++"
echo "|| $PRGNAM-$VERSION"
echo "++"
-# Safety net 8-)
-if [ "$PKG" = "" -o "$PKG" = "/" ] ; then
- cat <<-EOT
- Your script sucks!!!
- You were about to delete the contents of your computer's hard disk!
- Please provide a value for the variable 'PKG'.
- EOT
- exit 1
-elif [ ! -d $PKG ]; then
- mkdir -p $PKG # place for the package to be built
-else
- rm -rf $PKG/* # We always erase old package's contents:
-fi
-
-cd $PKG
-
# Explode the package framework:
-if [ -f $CWD/_$PRGNAM.tar.gz ]; then
- explodepkg $CWD/_$PRGNAM.tar.gz
+if [ -f $SRCDIR/_$PRGNAM.tar.gz ]; then
+ cd $PKG
+ explodepkg $SRCDIR/_$PRGNAM.tar.gz
+ cd -
fi
cd $TMP/tmp-$PRGNAM
-
-
-# --- TARBALL EXTRACTION,PATCH,MODIFY ---
-
echo "Extracting the source archive(s) for $PRGNAM..."
-for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
- if `file $CWD/${SOURCE[$i]} | grep -q ": bzip2"`; then
- tar -xjvf $CWD/${SOURCE[$i]}
- elif `file $CWD/${SOURCE[$i]} | grep -qi ": zip"`; then
- unzip $CWD/${SOURCE[$i]}
- elif `file $CWD/${SOURCE[$i]} | grep -qi ": 7-zip"`; then
- 7za -x $CWD/${SOURCE[$i]}
- else
- tar -xzvf $CWD/${SOURCE[$i]}
- fi
-done
+if $(file ${SOURCE} | grep -qi ": 7-zip"); then
+ 7za x ${SOURCE}
+elif $(file ${SOURCE} | grep -qi ": zip"); then
+ unzip ${SOURCE}
+else
+ tar -xvf ${SOURCE}
+fi
cd ${PRGNAM}-${VERSION}
-
-chown -R root.root *
-find . -perm 777 -exec chmod 755 {} \;
-
-
-# --- BUILDING ---
+chown -R root:root .
+chmod -R u+w,go+r-w,a+X-s .
echo Building ...
-
LDFLAGS="$SLKLDFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
CFLAGS="$SLKCFLAGS" \
-./configure --prefix=/usr \
- --libdir=/usr/lib${LIBDIRSUFFIX} \
- --localstatedir=/var \
- --sysconfdir=/etc \
- $ARCH-slackware-linux \
- 2>&1 | tee $CWD/configure-${PRGNAM}.log
-make 2>&1 | tee $CWD/make-${PRGNAM}.log
-
-#
-# Install all the needed stuff to the package dir
-#
-# Use installwatch if available:
-which installwatch > /dev/null 2>&1
-if [ $? == 0 ]; then
- installwatch -o $CWD/install-${PRGNAM}.log make DESTDIR=$PKG install
-else
- make DESTDIR=$PKG install 2>&1 |tee $CWD/install-${PRGNAM}.log
-fi
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --mandir=/usr/man \
+ --docdir=/usr/doc/$PRGNAM-$VERSION \
+ --localstatedir=/var \
+ --sysconfdir=/etc \
+ --program-prefix= \
+ --program-suffix= \
+ --build=$ARCH-slackware-linux \
+ 2>&1 | tee $OUTPUT/configure-${PRGNAM}.log
+
+make $NUMJOBS 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
+make DESTDIR=$PKG install 2>&1 | tee $OUTPUT/install-${PRGNAM}.log
# Install a configuration file if needed
cp $PKG/etc/rsnapshot.conf.{default,new}
-
-# --- DOINST.SH ---
-
-# And now write the doinst.sh :
+# Add this to the doinst.sh:
mkdir -p $PKG/install
-cat <<EEOOTT > $PKG/install/doinst.sh
+cat <<EOINS >> $PKG/install/doinst.sh
# Handle the incoming configuration files:
config() {
for infile in \$1; do
@@ -201,65 +202,39 @@ config() {
done
}
-# Take care of rsnapshot.conf
config etc/rsnapshot.conf.new
-EEOOTT
-
-
-# --- DOCUMENTATION ---
+EOINS
+# Add documentation:
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
-cp -a $DOCS \
- $PKG/usr/doc/$PRGNAM-$VERSION
-chmod -R a-w $PKG/usr/doc/$PRGNAM-$VERSION/*
-
-# Compress the man page(s)
-[ -d $PKG/usr/man ] && find $PKG/usr/man -type f -name "*.?" -exec gzip -9 {} \;
-
-# Strip binaries
-( cd $PKG
- find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
- find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
-)
-
-
-# --- OWNERSHIP, RIGHTS ---
-
-chmod -R o-w $PKG
-for BD in $PKG/usr/{,s}bin $PKG/{,s}bin $PKG/usr/X11R6/bin $PKG/opt/kde/bin ;
-do [ -d $BD ] && chown root:bin $BD/* ; done
-
-
-# --- PACKAGE DESCRIPTION ---
-
-mkdir -p $PKG/install
-cat $CWD/slack-desc > $PKG/install/slack-desc
-if [ -f $CWD/doinst.sh ]; then
- cat $CWD/doinst.sh > $PKG/install/doinst.sh
-fi
-if [ -f $CWD/slack-requires ]; then
- cat $CWD/slack-requires > $PKG/install/slack-requires
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
+cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# Compress the man page(s):
+if [ -d $PKG/usr/man ]; then
+ find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
+ for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
fi
+# Strip binaries (if any):
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
-# --- BUILDING ---
+# Add a package description:
+mkdir -p $PKG/install
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
# Build the package:
cd $PKG
-makepkg --linkadd y --chown n $TMP/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz \
- 2>&1 | tee $CWD/makepkg-${PRGNAM}.log
-(cd $TMP && md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz.md5)
-cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $TMP/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.txt
-if [ -f $PKG/install/slack-requires ]; then
- cat $PKG/install/slack-requires > $TMP/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.dep
-fi
-
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz}.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
-# --- CLEANUP ---
+# Restore the original umask:
+umask ${_UMASK_}
-# Clean up the extra stuff:
-if [ "$1" = "--cleanup" ]; then
- rm -rf $TMP/tmp-$PRGNAM
- rm -rf $PKG
-fi